Index: cpukit/libblock/src/bdbuf.c
===================================================================
--- cpukit/libblock/src/bdbuf.c	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/libblock/src/bdbuf.c	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -846,261 +918,385 @@
 
 /**
- * Initialize single buffer pool.
- *
- * @param config Buffer pool configuration
- * @param pid Pool number
- *
- * @return RTEMS_SUCCESSFUL, if buffer pool initialized successfully, or error
- *         code if error occured.
- */
-static rtems_status_code
-rtems_bdbuf_initialize_pool (rtems_bdbuf_pool_config* config,
-                             rtems_bdpool_id          pid)
-{
-  int                 rv = 0;
-  unsigned char*      buffer = config->mem_area;
-  rtems_bdbuf_pool*   pool;
+ * Compute the number of BDs per group for a given buffer size.
+ *
+ * @param size The buffer size. It can be any size and we scale up.
+ */
+static size_t
+rtems_bdbuf_bds_per_group (size_t size)
+{
+  size_t bufs_per_size;
+  size_t bds_per_size;
+  
+  if (size > rtems_bdbuf_configuration.buffer_max)
+    return 0;
+  
+  bufs_per_size = ((size - 1) / bdbuf_config.buffer_min) + 1;
+  
+  for (bds_per_size = 1;
+       bds_per_size < bufs_per_size;
+       bds_per_size <<= 1)
+    ;
+
+  return bdbuf_cache.max_bds_per_group / bds_per_size;
+}
+
+/**
+ * Reallocate a group. The BDs currently allocated in the group are removed
+ * from the ALV tree and any lists then the new BD's are prepended to the ready
+ * list of the cache.
+ *
+ * @param group The group to reallocate.
+ * @param new_bds_per_group The new count of BDs per group.
+ */
+static void
+rtems_bdbuf_group_realloc (rtems_bdbuf_group* group, size_t new_bds_per_group)
+{
   rtems_bdbuf_buffer* bd;
+  int                 b;
+  size_t              bufs_per_bd;
+
+  bufs_per_bd = bdbuf_cache.max_bds_per_group / group->bds_per_group;
+  
+  for (b = 0, bd = group->bdbuf;
+       b < group->bds_per_group;
+       b++, bd += bufs_per_bd)
+  {
+    if ((bd->state == RTEMS_BDBUF_STATE_CACHED) ||
+        (bd->state == RTEMS_BDBUF_STATE_MODIFIED) ||
+        (bd->state == RTEMS_BDBUF_STATE_READ_AHEAD))
+    {
+      if (rtems_bdbuf_avl_remove (&bdbuf_cache.tree, bd) != 0)
+        rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_CONSISTENCY);
+      rtems_chain_extract (&bd->link);
+    }
+  }
+  
+  group->bds_per_group = new_bds_per_group;
+  bufs_per_bd = bdbuf_cache.max_bds_per_group / new_bds_per_group;
+  
+  for (b = 0, bd = group->bdbuf;
+       b < group->bds_per_group;
+       b++, bd += bufs_per_bd)
+    rtems_chain_prepend (&bdbuf_cache.ready, &bd->link);
+}
+
+/**
+ * Get the next BD from the list. This call assumes the cache is locked.
+ *
+ * @param bds_per_group The number of BDs per block we are need.
+ * @param list The list to find the BD on.
+ * @return The next BD if found or NULL is none are available.
+ */
+static rtems_bdbuf_buffer*
+rtems_bdbuf_get_next_bd (size_t               bds_per_group,
+                         rtems_chain_control* list)
+{
+  rtems_chain_node* node = rtems_chain_first (list);
+  while (!rtems_chain_is_tail (list, node))
+  {
+    rtems_bdbuf_buffer* bd = (rtems_bdbuf_buffer*) node;
+
+    /*
+     * If this bd is already part of a group that supports the same number of
+     * BDs per group return it. If the bd is part of another group check the
+     * number of users and if 0 we can take this group and resize it.
+     */
+    if (bd->group->bds_per_group == bds_per_group)
+    {
+      rtems_chain_extract (node);
+      bd->group->users++;
+      return bd;
+    }
+
+    if (bd->group->users == 0)
+    {
+      /*
+       * We use the group to locate the start of the BDs for this group.
+       */
+      rtems_bdbuf_group_realloc (bd->group, bds_per_group);
+      bd = (rtems_bdbuf_buffer*) rtems_chain_get (&bdbuf_cache.ready);
+      return bd;
+    }
+
+    node = rtems_chain_next (node);
+  }
+  
+  return NULL;
+}
+
+/**
+ * Initialise the cache.
+ *
+ * @return rtems_status_code The initialisation status.
+ */
+rtems_status_code
+rtems_bdbuf_init (void)
+{
+  rtems_bdbuf_group*  group;
+  rtems_bdbuf_buffer* bd;
+  uint8_t*            buffer;
+  int                 b;
+  int                 cache_aligment;
   rtems_status_code   sc;
-  uint32_t            b;
-  int                 cache_aligment = 32 /* FIXME rtems_cache_get_data_line_size() */;
-
-  /* For unspecified cache alignments we use the CPU alignment */
+
+#if RTEMS_BDBUF_TRACE
+  rtems_bdbuf_printf ("init\n");
+#endif
+
+  /*
+   * Check the configuration table values.
+   */
+  if ((bdbuf_config.buffer_max % bdbuf_config.buffer_min) != 0)
+    return RTEMS_INVALID_NUMBER;
+  
+  /*
+   * We use a special variable to manage the initialisation incase we have
+   * completing threads doing this. You may get errors if the another thread
+   * makes a call and we have not finished initialisation.
+   */
+  if (bdbuf_cache.initialised)
+    return RTEMS_RESOURCE_IN_USE;
+
+  bdbuf_cache.initialised = true;
+  
+  /*
+   * For unspecified cache alignments we use the CPU alignment.
+   */
+  cache_aligment = 32; /* FIXME rtems_cache_get_data_line_size() */
   if (cache_aligment <= 0)
-  {
     cache_aligment = CPU_ALIGNMENT;
-  }
-
-  pool = rtems_bdbuf_get_pool (pid);
-  
-  pool->blksize        = config->size;
-  pool->nblks          = config->num;
-  pool->flags          = 0;
-  pool->sync_active    = false;
-  pool->sync_device    = -1;
-  pool->sync_requester = 0;
-  pool->tree           = NULL;
-  pool->buffers        = NULL;
-
-  rtems_chain_initialize_empty (&pool->ready);
-  rtems_chain_initialize_empty (&pool->lru);
-  rtems_chain_initialize_empty (&pool->modified);
-  rtems_chain_initialize_empty (&pool->sync);
-
-  pool->access           = 0;
-  pool->access_waiters   = 0;
-  pool->transfer         = 0;
-  pool->transfer_waiters = 0;
-  pool->waiting          = 0;
-  pool->wait_waiters     = 0;
-  
-  /*
-   * Allocate memory for buffer descriptors
-   */
-  pool->bds = calloc (config->num, sizeof (rtems_bdbuf_buffer));
-  
-  if (!pool->bds)
+
+  bdbuf_cache.sync_active    = false;
+  bdbuf_cache.sync_device    = -1;
+  bdbuf_cache.sync_requester = 0;
+  bdbuf_cache.tree           = NULL;
+
+  rtems_chain_initialize_empty (&bdbuf_cache.swapout_workers);
+  rtems_chain_initialize_empty (&bdbuf_cache.ready);
+  rtems_chain_initialize_empty (&bdbuf_cache.lru);
+  rtems_chain_initialize_empty (&bdbuf_cache.modified);
+  rtems_chain_initialize_empty (&bdbuf_cache.sync);
+
+  bdbuf_cache.access           = 0;
+  bdbuf_cache.access_waiters   = 0;
+  bdbuf_cache.transfer         = 0;
+  bdbuf_cache.transfer_waiters = 0;
+  bdbuf_cache.waiting          = 0;
+  bdbuf_cache.wait_waiters     = 0;
+
+  /*
+   * Create the locks for the cache.
+   */
+  sc = rtems_semaphore_create (rtems_build_name ('B', 'D', 'C', 'l'),
+                               1, RTEMS_BDBUF_CACHE_LOCK_ATTRIBS, 0,
+                               &bdbuf_cache.lock);
+  if (sc != RTEMS_SUCCESSFUL)
+  {
+    bdbuf_cache.initialised = false;
+    return sc;
+  }
+
+  rtems_bdbuf_lock_cache ();
+  
+  sc = rtems_semaphore_create (rtems_build_name ('B', 'D', 'C', 's'),
+                               1, RTEMS_BDBUF_CACHE_LOCK_ATTRIBS, 0,
+                               &bdbuf_cache.sync_lock);
+  if (sc != RTEMS_SUCCESSFUL)
+  {
+    rtems_bdbuf_unlock_cache ();
+    rtems_semaphore_delete (bdbuf_cache.lock);
+    bdbuf_cache.initialised = false;
+    return sc;
+  }
+  
+  sc = rtems_semaphore_create (rtems_build_name ('B', 'D', 'C', 'a'),
+                               0, RTEMS_BDBUF_CACHE_WAITER_ATTRIBS, 0,
+                               &bdbuf_cache.access);
+  if (sc != RTEMS_SUCCESSFUL)
+  {
+    rtems_semaphore_delete (bdbuf_cache.sync_lock);
+    rtems_bdbuf_unlock_cache ();
+    rtems_semaphore_delete (bdbuf_cache.lock);
+    bdbuf_cache.initialised = false;
+    return sc;
+  }
+
+  sc = rtems_semaphore_create (rtems_build_name ('B', 'D', 'C', 't'),
+                               0, RTEMS_BDBUF_CACHE_WAITER_ATTRIBS, 0,
+                               &bdbuf_cache.transfer);
+  if (sc != RTEMS_SUCCESSFUL)
+  {
+    rtems_semaphore_delete (bdbuf_cache.access);
+    rtems_semaphore_delete (bdbuf_cache.sync_lock);
+    rtems_bdbuf_unlock_cache ();
+    rtems_semaphore_delete (bdbuf_cache.lock);
+    bdbuf_cache.initialised = false;
+    return sc;
+  }
+
+  sc = rtems_semaphore_create (rtems_build_name ('B', 'D', 'C', 'w'),
+                               0, RTEMS_BDBUF_CACHE_WAITER_ATTRIBS, 0,
+                               &bdbuf_cache.waiting);
+  if (sc != RTEMS_SUCCESSFUL)
+  {
+    rtems_semaphore_delete (bdbuf_cache.transfer);
+    rtems_semaphore_delete (bdbuf_cache.access);
+    rtems_semaphore_delete (bdbuf_cache.sync_lock);
+    rtems_bdbuf_unlock_cache ();
+    rtems_semaphore_delete (bdbuf_cache.lock);
+    bdbuf_cache.initialised = false;
+    return sc;
+  }
+  
+  /*
+   * Allocate the memory for the buffer descriptors.
+   */
+  bdbuf_cache.bds = calloc (sizeof (rtems_bdbuf_buffer),
+                            bdbuf_config.size / bdbuf_config.buffer_min);
+  if (!bdbuf_cache.bds)
+  {
+    rtems_semaphore_delete (bdbuf_cache.transfer);
+    rtems_semaphore_delete (bdbuf_cache.access);
+    rtems_semaphore_delete (bdbuf_cache.sync_lock);
+    rtems_bdbuf_unlock_cache ();
+    rtems_semaphore_delete (bdbuf_cache.lock);
+    bdbuf_cache.initialised = false;
     return RTEMS_NO_MEMORY;
-
-  /*
-   * Allocate memory for buffers if required.  The pool memory will be cache
-   * aligned.  It is possible to free the memory allocated by rtems_memalign()
-   * with free().
-   */
-  if (buffer == NULL)
-  {
-    rv = rtems_memalign ((void **) &buffer,
-                         cache_aligment,
-                         config->num * config->size);
-    if (rv != 0)
-    {
-      free (pool->bds);
-      return RTEMS_NO_MEMORY;
-    }
-    pool->buffers = buffer;
-  }
-
-  for (b = 0, bd = pool->bds;
-       b < pool->nblks;
-       b++, bd++, buffer += pool->blksize)
+  }
+
+  /*
+   * Compute the various number of elements in the cache.
+   */
+  bdbuf_cache.buffer_min_count =
+    bdbuf_config.size / bdbuf_config.buffer_min;
+  bdbuf_cache.max_bds_per_group =
+    bdbuf_config.buffer_max / bdbuf_config.buffer_min;
+  bdbuf_cache.group_count =
+    bdbuf_cache.buffer_min_count / bdbuf_cache.max_bds_per_group;
+
+  /*
+   * Allocate the memory for the buffer descriptors.
+   */
+  bdbuf_cache.groups = calloc (sizeof (rtems_bdbuf_group),
+                               bdbuf_cache.group_count);
+  if (!bdbuf_cache.groups)
+  {
+    free (bdbuf_cache.bds);
+    rtems_semaphore_delete (bdbuf_cache.transfer);
+    rtems_semaphore_delete (bdbuf_cache.access);
+    rtems_semaphore_delete (bdbuf_cache.sync_lock);
+    rtems_bdbuf_unlock_cache ();
+    rtems_semaphore_delete (bdbuf_cache.lock);
+    bdbuf_cache.initialised = false;
+    return RTEMS_NO_MEMORY;
+  }
+  
+  /*
+   * Allocate memory for buffer memory. The buffer memory will be cache
+   * aligned. It is possible to free the memory allocated by rtems_memalign()
+   * with free(). Return 0 if allocated.
+   */
+  if (rtems_memalign ((void **) &bdbuf_cache.buffers,
+                      cache_aligment,
+                      bdbuf_cache.buffer_min_count * bdbuf_config.buffer_min) != 0)
+  {
+    free (bdbuf_cache.groups);
+    free (bdbuf_cache.bds);
+    rtems_semaphore_delete (bdbuf_cache.transfer);
+    rtems_semaphore_delete (bdbuf_cache.access);
+    rtems_semaphore_delete (bdbuf_cache.sync_lock);
+    rtems_bdbuf_unlock_cache ();
+    rtems_semaphore_delete (bdbuf_cache.lock);
+    bdbuf_cache.initialised = false;
+    return RTEMS_NO_MEMORY;
+  }
+
+  /*
+   * The cache is empty after opening so we need to add all the buffers to it
+   * and initialise the groups.
+   */
+  for (b = 0, group = bdbuf_cache.groups,
+         bd = bdbuf_cache.bds, buffer = bdbuf_cache.buffers;
+       b < bdbuf_cache.buffer_min_count;
+       b++, bd++, buffer += bdbuf_config.buffer_min)
   {
     bd->dev        = -1;
-    bd->block      = 0;
+    bd->group      = group;
     bd->buffer     = buffer;
     bd->avl.left   = NULL;
     bd->avl.right  = NULL;
     bd->state      = RTEMS_BDBUF_STATE_EMPTY;
-    bd->pool       = pid;
     bd->error      = 0;
     bd->waiters    = 0;
     bd->hold_timer = 0;
     
-    rtems_chain_append (&pool->ready, &bd->link);
-  }
-
-  sc = rtems_semaphore_create (rtems_build_name ('B', 'P', '0' + pid, 'L'),
-                               1, RTEMS_BDBUF_POOL_LOCK_ATTRIBS, 0,
-                               &pool->lock);
-  if (sc != RTEMS_SUCCESSFUL)
-  {
-    free (pool->buffers);
-    free (pool->bds);
-    return sc;
-  }
-
-  sc = rtems_semaphore_create (rtems_build_name ('B', 'P', '0' + pid, 'S'),
-                               1, RTEMS_BDBUF_POOL_LOCK_ATTRIBS, 0,
-                               &pool->sync_lock);
-  if (sc != RTEMS_SUCCESSFUL)
-  {
-    rtems_semaphore_delete (pool->lock);
-    free (pool->buffers);
-    free (pool->bds);
-    return sc;
-  }
-  
-  sc = rtems_semaphore_create (rtems_build_name ('B', 'P', '0' + pid, 'a'),
-                               0, RTEMS_BDBUF_POOL_WAITER_ATTRIBS, 0,
-                               &pool->access);
-  if (sc != RTEMS_SUCCESSFUL)
-  {
-    rtems_semaphore_delete (pool->sync_lock);
-    rtems_semaphore_delete (pool->lock);
-    free (pool->buffers);
-    free (pool->bds);
-    return sc;
-  }
-
-  sc = rtems_semaphore_create (rtems_build_name ('B', 'P', '0' + pid, 't'),
-                               0, RTEMS_BDBUF_POOL_WAITER_ATTRIBS, 0,
-                               &pool->transfer);
-  if (sc != RTEMS_SUCCESSFUL)
-  {
-    rtems_semaphore_delete (pool->access);
-    rtems_semaphore_delete (pool->sync_lock);
-    rtems_semaphore_delete (pool->lock);
-    free (pool->buffers);
-    free (pool->bds);
-    return sc;
-  }
-
-  sc = rtems_semaphore_create (rtems_build_name ('B', 'P', '0' + pid, 'w'),
-                               0, RTEMS_BDBUF_POOL_WAITER_ATTRIBS, 0,
-                               &pool->waiting);
-  if (sc != RTEMS_SUCCESSFUL)
-  {
-    rtems_semaphore_delete (pool->transfer);
-    rtems_semaphore_delete (pool->access);
-    rtems_semaphore_delete (pool->sync_lock);
-    rtems_semaphore_delete (pool->lock);
-    free (pool->buffers);
-    free (pool->bds);
-    return sc;
-  }
-
-  return RTEMS_SUCCESSFUL;
-}
-
-/**
- * Free resources allocated for buffer pool with specified number.
- *
- * @param pid Buffer pool number
- *
- * @retval RTEMS_SUCCESSFUL
- */
-static rtems_status_code
-rtems_bdbuf_release_pool (rtems_bdpool_id pid)
-{
-  rtems_bdbuf_pool* pool = rtems_bdbuf_get_pool (pid);
-  
-  rtems_bdbuf_lock_pool (pool);
-
-  rtems_semaphore_delete (pool->waiting);
-  rtems_semaphore_delete (pool->transfer);
-  rtems_semaphore_delete (pool->access);
-  rtems_semaphore_delete (pool->lock);
-  
-  free (pool->buffers);
-  free (pool->bds);
-  
-  return RTEMS_SUCCESSFUL;
-}
-
-rtems_status_code
-rtems_bdbuf_init (void)
-{
-  rtems_bdpool_id   p;
-  rtems_status_code sc;
-
-#if RTEMS_BDBUF_TRACE
-  rtems_bdbuf_printf ("init\n");
-#endif
-
-  if (rtems_bdbuf_pool_configuration_size <= 0)
-    return RTEMS_INVALID_SIZE;
-
-  if (rtems_bdbuf_ctx.npools)
-    return RTEMS_RESOURCE_IN_USE;
-
-  rtems_bdbuf_ctx.npools = rtems_bdbuf_pool_configuration_size;
-
-  /*
-   * Allocate memory for buffer pool descriptors
-   */
-  rtems_bdbuf_ctx.pool = calloc (rtems_bdbuf_pool_configuration_size,
-                                 sizeof (rtems_bdbuf_pool));
-  
-  if (rtems_bdbuf_ctx.pool == NULL)
-    return RTEMS_NO_MEMORY;
-
-  /*
-   * Initialize buffer pools and roll out if something failed,
-   */
-  for (p = 0; p < rtems_bdbuf_ctx.npools; p++)
-  {
-    sc = rtems_bdbuf_initialize_pool (&rtems_bdbuf_pool_configuration[p], p);
-    if (sc != RTEMS_SUCCESSFUL)
-    {
-      rtems_bdpool_id j;
-      for (j = 0; j < p - 1; j++)
-        rtems_bdbuf_release_pool (j);
-      return sc;
-    }
-  }
-
-  /*
-   * Create and start swapout task
-   */
-
-  rtems_bdbuf_ctx.swapout_enabled = true;
+    rtems_chain_append (&bdbuf_cache.ready, &bd->link);
+
+    if ((b % bdbuf_cache.max_bds_per_group) ==
+        (bdbuf_cache.max_bds_per_group - 1))
+      group++;
+  }
+
+  for (b = 0,
+         group = bdbuf_cache.groups,
+         bd = bdbuf_cache.bds;
+       b < bdbuf_cache.group_count;
+       b++,
+         group++,
+         bd += bdbuf_cache.max_bds_per_group)
+  {
+    group->bds_per_group = bdbuf_cache.max_bds_per_group;
+    group->users = 0;
+    group->bdbuf = bd;
+  }
+         
+  /*
+   * Create and start swapout task. This task will create and manage the worker
+   * threads.
+   */
+  bdbuf_cache.swapout_enabled = true;
   
   sc = rtems_task_create (rtems_build_name('B', 'S', 'W', 'P'),
-                          (rtems_bdbuf_configuration.swapout_priority ?
-                           rtems_bdbuf_configuration.swapout_priority :
+                          (bdbuf_config.swapout_priority ?
+                           bdbuf_config.swapout_priority :
                            RTEMS_BDBUF_SWAPOUT_TASK_PRIORITY_DEFAULT),
                           SWAPOUT_TASK_STACK_SIZE,
                           RTEMS_PREEMPT | RTEMS_NO_TIMESLICE | RTEMS_NO_ASR,
                           RTEMS_LOCAL | RTEMS_NO_FLOATING_POINT,
-                          &rtems_bdbuf_ctx.swapout);
+                          &bdbuf_cache.swapout);
   if (sc != RTEMS_SUCCESSFUL)
   {
-    for (p = 0; p < rtems_bdbuf_ctx.npools; p++)
-      rtems_bdbuf_release_pool (p);
-    free (rtems_bdbuf_ctx.pool);
+    free (bdbuf_cache.buffers);
+    free (bdbuf_cache.groups);
+    free (bdbuf_cache.bds);
+    rtems_semaphore_delete (bdbuf_cache.transfer);
+    rtems_semaphore_delete (bdbuf_cache.access);
+    rtems_semaphore_delete (bdbuf_cache.sync_lock);
+    rtems_bdbuf_unlock_cache ();
+    rtems_semaphore_delete (bdbuf_cache.lock);
+    bdbuf_cache.initialised = false;
     return sc;
   }
 
-  sc = rtems_task_start (rtems_bdbuf_ctx.swapout,
+  sc = rtems_task_start (bdbuf_cache.swapout,
                          rtems_bdbuf_swapout_task,
-                         (rtems_task_argument) &rtems_bdbuf_ctx);
+                         (rtems_task_argument) &bdbuf_cache);
   if (sc != RTEMS_SUCCESSFUL)
   {
-    rtems_task_delete (rtems_bdbuf_ctx.swapout);
-    for (p = 0; p < rtems_bdbuf_ctx.npools; p++)
-      rtems_bdbuf_release_pool (p);
-    free (rtems_bdbuf_ctx.pool);
+    rtems_task_delete (bdbuf_cache.swapout);
+    free (bdbuf_cache.buffers);
+    free (bdbuf_cache.groups);
+    free (bdbuf_cache.bds);
+    rtems_semaphore_delete (bdbuf_cache.transfer);
+    rtems_semaphore_delete (bdbuf_cache.access);
+    rtems_semaphore_delete (bdbuf_cache.sync_lock);
+    rtems_bdbuf_unlock_cache ();
+    rtems_semaphore_delete (bdbuf_cache.lock);
+    bdbuf_cache.initialised = false;
     return sc;
   }
 
+  rtems_bdbuf_unlock_cache ();
+  
   return RTEMS_SUCCESSFUL;
 }
@@ -1109,27 +1305,27 @@
  * Get a buffer for this device and block. This function returns a buffer once
  * placed into the AVL tree. If no buffer is available and it is not a read
- * ahead request and no buffers are waiting to the written to disk wait until
- * one is available. If buffers are waiting to be written to disk and non are
- * available expire the hold timer and wake the swap out task. If the buffer is
- * for a read ahead transfer return NULL if there is not buffer or it is in the
- * cache.
- *
- * The AVL tree of buffers for the pool is searched and if not located check
- * obtain a buffer and insert it into the AVL tree. Buffers are first obtained
- * from the ready list until all empty/ready buffers are used. Once all buffers
- * are in use buffers are taken from the LRU list with the least recently used
- * buffer taken first. A buffer taken from the LRU list is removed from the AVL
- * tree. The ready list or LRU list buffer is initialised to this device and
- * block. If no buffers are available due to the ready and LRU lists being
- * empty a check is made of the modified list. Buffers may be queued waiting
- * for the hold timer to expire. These buffers should be written to disk and
- * returned to the LRU list where they can be used rather than this call
- * blocking. If buffers are on the modified list the max. write block size of
- * buffers have their hold timer expired and the swap out task woken. The
- * caller then blocks on the waiting semaphore and counter. When buffers return
- * from the upper layers (access) or lower driver (transfer) the blocked caller
- * task is woken and this procedure is repeated. The repeat handles a case of a
- * another thread pre-empting getting a buffer first and adding it to the AVL
- * tree.
+ * ahead request and no buffers are waiting to the written to disk wait until a
+ * buffer is available. If buffers are waiting to be written to disk and none
+ * are available expire the hold timer's of the queued buffers and wake the
+ * swap out task. If the buffer is for a read ahead transfer return NULL if
+ * there are no buffers available or the buffer is already in the cache.
+ *
+ * The AVL tree of buffers for the cache is searched and if not found obtain a
+ * buffer and insert it into the AVL tree. Buffers are first obtained from the
+ * ready list until all empty/ready buffers are used. Once all buffers are in
+ * use the LRU list is searched for a buffer of the same group size or a group
+ * that has no active buffers in use. A buffer taken from the LRU list is
+ * removed from the AVL tree and assigned the new block number. The ready or
+ * LRU list buffer is initialised to this device and block. If no buffers are
+ * available due to the ready and LRU lists being empty a check is made of the
+ * modified list. Buffers may be queued waiting for the hold timer to
+ * expire. These buffers should be written to disk and returned to the LRU list
+ * where they can be used. If buffers are on the modified list the max. write
+ * block size of buffers have their hold timer's expired and the swap out task
+ * woken. The caller then blocks on the waiting semaphore and counter. When
+ * buffers return from the upper layers (access) or lower driver (transfer) the
+ * blocked caller task is woken and this procedure is repeated. The repeat
+ * handles a case of a another thread pre-empting getting a buffer first and
+ * adding it to the AVL tree.
  *
  * A buffer located in the AVL tree means it is already in the cache and maybe
@@ -1143,35 +1339,43 @@
  * and return to the user.
  *
- * This function assumes the pool the buffer is being taken from is locked and
- * it will make sure the pool is locked when it returns. The pool will be
+ * This function assumes the cache the buffer is being taken from is locked and
+ * it will make sure the cache is locked when it returns. The cache will be
  * unlocked if the call could block.
  *
- * @param pdd The physical disk device
- * @param pool The pool reference
- * @param block Absolute media block number
- * @param read_ahead The get is for a read ahead buffer
- *
- * @return RTEMS status code ( if operation completed successfully or error
+ * Variable sized buffer is handled by groups. A group is the size of the
+ * maximum buffer that can be allocated. The group can size in multiples of the
+ * minimum buffer size where the mulitples are 1,2,4,8, etc. If the buffer is
+ * found in the AVL tree the number of BDs in the group is check and if
+ * different the buffer size for the block has changed. The buffer needs to be
+ * invalidated.
+ *
+ * @param dd The disk device. Has the configured block size.
+ * @param bds_per_group The number of BDs in a group for this block.
+ * @param block Absolute media block number for the device
+ * @param read_ahead The get is for a read ahead buffer if true
+ * @return RTEMS status code (if operation completed successfully or error
  *         code if error is occured)
  */
 static rtems_bdbuf_buffer*
-rtems_bdbuf_get_buffer (rtems_disk_device* pdd,
-                        rtems_bdbuf_pool*  pool,
+rtems_bdbuf_get_buffer (rtems_disk_device* dd,
+                        size_t             bds_per_group,
                         rtems_blkdev_bnum  block,
                         bool               read_ahead)
 {
-  dev_t               device = pdd->dev;
+  dev_t               device = dd->dev;
   rtems_bdbuf_buffer* bd;
   bool                available;
-
+  
   /*
    * Loop until we get a buffer. Under load we could find no buffers are
    * available requiring this task to wait until some become available before
-   * proceeding. There is no timeout. If the call is to block and the buffer is
-   * for a read ahead buffer return NULL.
+   * proceeding. There is no timeout. If this call is to block and the buffer
+   * is for a read ahead buffer return NULL. The read ahead is nice but not
+   * that important.
    *
    * The search procedure is repeated as another thread could have pre-empted
    * us while we waited for a buffer, obtained an empty buffer and loaded the
-   * AVL tree with the one we are after.
+   * AVL tree with the one we are after. In this case we move down and wait for
+   * the buffer to return to the cache.
    */
   do
@@ -1180,5 +1384,5 @@
      * Search for buffer descriptor for this dev/block key.
      */
-    bd = rtems_bdbuf_avl_search (&pool->tree, device, block);
+    bd = rtems_bdbuf_avl_search (&bdbuf_cache.tree, device, block);
 
     /*
@@ -1195,17 +1399,20 @@
     {
       /*
-       * Assign new buffer descriptor from the empty list if one is present. If
-       * the empty queue is empty get the oldest buffer from LRU list. If the
+       * Assign new buffer descriptor from the ready list if one is present. If
+       * the ready queue is empty get the oldest buffer from LRU list. If the
        * LRU list is empty there are no available buffers check the modified
        * list.
        */
-      if (rtems_chain_is_empty (&pool->ready))
+      bd = rtems_bdbuf_get_next_bd (bds_per_group, &bdbuf_cache.ready);
+
+      if (!bd)
       {
         /*
-         * No unsed or read-ahead buffers.
+         * No unused or read-ahead buffers.
          *
          * If this is a read ahead buffer just return. No need to place further
          * pressure on the cache by reading something that may be needed when
-         * we have data in the cache that was needed and may still be.
+         * we have data in the cache that was needed and may still be in the
+         * future.
          */
         if (read_ahead)
@@ -1215,5 +1422,5 @@
          * Check the LRU list.
          */
-        bd = (rtems_bdbuf_buffer *) rtems_chain_get (&pool->lru);
+        bd = rtems_bdbuf_get_next_bd (bds_per_group, &bdbuf_cache.lru);
         
         if (bd)
@@ -1222,5 +1429,5 @@
            * Remove the buffer from the AVL tree.
            */
-          if (rtems_bdbuf_avl_remove (&pool->tree, bd) != 0)
+          if (rtems_bdbuf_avl_remove (&bdbuf_cache.tree, bd) != 0)
             rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_CONSISTENCY);
         }
@@ -1230,18 +1437,20 @@
            * If there are buffers on the modified list expire the hold timer
            * and wake the swap out task then wait else just go and wait.
+           *
+           * The check for an empty list is made so the swapper is only woken
+           * when if timers are changed.
            */
-          if (!rtems_chain_is_empty (&pool->modified))
+          if (!rtems_chain_is_empty (&bdbuf_cache.modified))
           {
-            rtems_chain_node* node = rtems_chain_head (&pool->modified);
+            rtems_chain_node* node = rtems_chain_first (&bdbuf_cache.modified);
             uint32_t          write_blocks = 0;
             
-            node = node->next;
-            while ((write_blocks < rtems_bdbuf_configuration.max_write_blocks) &&
-                   !rtems_chain_is_tail (&pool->modified, node))
+            while ((write_blocks < bdbuf_config.max_write_blocks) &&
+                   !rtems_chain_is_tail (&bdbuf_cache.modified, node))
             {
               rtems_bdbuf_buffer* bd = (rtems_bdbuf_buffer*) node;
               bd->hold_timer = 0;
               write_blocks++;
-              node = node->next;
+              node = rtems_chain_next (node);
             }
 
@@ -1250,14 +1459,15 @@
           
           /*
-           * Wait for a buffer to be returned to the pool. The buffer will be
+           * Wait for a buffer to be returned to the cache. The buffer will be
            * placed on the LRU list.
            */
-          rtems_bdbuf_wait (pool, &pool->waiting, &pool->wait_waiters);
+          rtems_bdbuf_wait (&bdbuf_cache.waiting, &bdbuf_cache.wait_waiters);
         }
       }
       else
       {
-        bd = (rtems_bdbuf_buffer *) rtems_chain_get (&(pool->ready));
-
+        /*
+         * We have a new buffer for this block.
+         */
         if ((bd->state != RTEMS_BDBUF_STATE_EMPTY) &&
             (bd->state != RTEMS_BDBUF_STATE_READ_AHEAD))
@@ -1266,5 +1476,5 @@
         if (bd->state == RTEMS_BDBUF_STATE_READ_AHEAD)
         {
-          if (rtems_bdbuf_avl_remove (&pool->tree, bd) != 0)
+          if (rtems_bdbuf_avl_remove (&bdbuf_cache.tree, bd) != 0)
             rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_CONSISTENCY);
         }
@@ -1281,8 +1491,22 @@
         bd->waiters   = 0;
 
-        if (rtems_bdbuf_avl_insert (&pool->tree, bd) != 0)
+        if (rtems_bdbuf_avl_insert (&bdbuf_cache.tree, bd) != 0)
           rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_CONSISTENCY);
 
         return bd;
+      }
+    }
+    else
+    {
+      /*
+       * We have the buffer for the block from the cache. Check if the buffer
+       * in the cache is the same size and the requested size we are after.
+       */
+      if (bd->group->bds_per_group != bds_per_group)
+      {
+        bd->state = RTEMS_BDBUF_STATE_EMPTY;
+        rtems_chain_extract (&bd->link);
+        rtems_chain_prepend (&bdbuf_cache.ready, &bd->link);
+        bd = NULL;
       }
     }
@@ -1315,5 +1539,6 @@
       case RTEMS_BDBUF_STATE_ACCESS_MODIFIED:
         bd->waiters++;
-        rtems_bdbuf_wait (pool, &pool->access, &pool->access_waiters);
+        rtems_bdbuf_wait (&bdbuf_cache.access,
+                          &bdbuf_cache.access_waiters);
         bd->waiters--;
         break;
@@ -1322,5 +1547,6 @@
       case RTEMS_BDBUF_STATE_TRANSFER:
         bd->waiters++;
-        rtems_bdbuf_wait (pool, &pool->transfer, &pool->transfer_waiters);
+        rtems_bdbuf_wait (&bdbuf_cache.transfer,
+                          &bdbuf_cache.transfer_waiters);
         bd->waiters--;
         break;
@@ -1345,23 +1571,31 @@
 {
   rtems_disk_device*  dd;
-  rtems_bdbuf_pool*   pool;
   rtems_bdbuf_buffer* bd;
-
-  /*
-   * Do not hold the pool lock when obtaining the disk table.
+  size_t              bds_per_group;
+
+  if (!bdbuf_cache.initialised)
+    return RTEMS_NOT_CONFIGURED;
+
+  /*
+   * Do not hold the cache lock when obtaining the disk table.
    */
   dd = rtems_disk_obtain (device);
-  if (dd == NULL)
+  if (!dd)
     return RTEMS_INVALID_ID;
 
   if (block >= dd->size)
+  {
+    rtems_disk_release (dd);
+    return RTEMS_INVALID_ADDRESS;
+  }
+
+  bds_per_group = rtems_bdbuf_bds_per_group (dd->block_size);
+  if (!bds_per_group)
   {
     rtems_disk_release (dd);
     return RTEMS_INVALID_NUMBER;
   }
-
-  pool = rtems_bdbuf_get_pool (dd->phys_dev->pool);
-  
-  rtems_bdbuf_lock_pool (pool);
+  
+  rtems_bdbuf_lock_cache ();
 
 #if RTEMS_BDBUF_TRACE
